unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin, ComCtrls;

type
  TECEPanel = record
    RowPanel: TPanel;
    SrcEdit: TEdit;
    InvCheck: TCheckBox;
    DstEdit: TEdit;
  end;

  type
  TPWMPanel = record
    RowPanel: TPanel;
    BitEdit: TEdit;
    InvCheck: TCheckBox;
    DutyEdit: TEdit;
  end;

  T_8254Ctr = record
    ModeList: TComboBox;
    LoadCheck: TCheckBox;
    LoadEdit: TEdit;
  end;

  T_8254Panel = record
    RowPanel: TPanel;
    msg1: TLabel;
    msg2:TLabel;
    msg3:TLabel;
    ctr: Array [0..2] of T_8254Ctr;
  end;

type
  TMainForm = class(TForm)
    ReadUSR: TButton;
    ReadDEFRaw: TButton;
    ReadPNP: TButton;
    GroupBox1: TGroupBox;
    RestoreTime: TTimer;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    WriteLenLabel: TLabel;
    ReqEdit: TEdit;
    ValueEdit: TEdit;
    IndexEdit: TEdit;
    WriteButton: TButton;
    ReadButton: TButton;
    ReadLenEdit: TEdit;
    WriteDataEdit: TEdit;
    ReadDataEdit: TEdit;
    SaveButton: TButton;
    AutosaveCheck: TCheckBox;
    SuccLabel: TLabel;
    SetDefaults: TButton;
    RestoreDefaults: TButton;
    WatchdogVR: TButton;
    WatchdogEEPROMVR: TButton;
    docMemo: TMemo;
    pnpTimer: TTimer;
    pnpMemo: TMemo;
    dioVR: TButton;
    DIOConfigVR: TButton;
    StatusBar1: TStatusBar;
    ctrPanel: TGroupBox;
    StartOutputFrequency: TButton;
    ctrModeLost: TButton;
    ctrModeOnly: TButton;
    ctrBlockEdit: TEdit;
    ctrEdit: TEdit;
    ctrModeEdit: TEdit;
    ctrLoadEdit: TEdit;
    actualFreqEdit: TEdit;
    freqEdit: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    dioBox: TGroupBox;
    dioCB: TCheckBox;
    daqTimer: TTimer;
    dioLabel: TLabel;
    ctrBox: TGroupBox;
    ctrLabel: TLabel;
    ctrCB: TCheckBox;
    LATCHPanel: TGroupBox;
    latchEdit: TEdit;
    latchBtn: TButton;
    DEBPanel: TGroupBox;
    debTickEdit: TEdit;
    Button1: TButton;
    debTimeEdit: TEdit;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    GlobalTickPanel: TGroupBox;
    Label17: TLabel;
    globalTickEdit: TEdit;
    Button2: TButton;
    pwmPanel: TGroupBox;
    Label18: TLabel;
    Label19: TLabel;
    pwmTickEdit: TEdit;
    Label20: TLabel;
    Label21: TLabel;
    pwmCountEdit: TEdit;
    pwmConfigButton: TButton;
    pwmSetCountButton: TButton;
    pwmDebugMemo: TMemo;
    Label22: TLabel;
    ltchCB: TCheckBox;
    debCB: TCheckBox;
    mapPanel: TGroupBox;
    mapSB: TScrollBox;
    Label27: TLabel;
    mapTickEdit: TEdit;
    mapCountEdit: TEdit;
    Label26: TLabel;
    Label25: TLabel;
    Label24: TLabel;
    Label23: TLabel;
    pwmSB: TScrollBox;
    mapSetCountButton: TButton;
    mapDebugMemo: TMemo;
    mapConfigButton: TButton;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    addrEdit: TEdit;
    dataEdit: TEdit;
    readBtn: TButton;
    writeBtn: TButton;
    PageControl1: TPageControl;
    DEFtabsheet: TTabSheet;
    wdgtabsheet: TTabSheet;
    iostructGB: TGroupBox;
    iostructDIOConLabel: TLabel;
    iostructDIOBytesLabel: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    _8254SB: TScrollBox;
    adcSB: TScrollBox;
    dacSB: TScrollBox;
    WDG_GB: TGroupBox;
    WDGiostructdioconLabel: TLabel;
    WDGiostructdiobytesLabel: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    WDG_8254SB: TScrollBox;
    WDGadcSB: TScrollBox;
    WDGdacSB: TScrollBox;
    wdgButton: TButton;
    defButton: TButton;
    wdgSecondsEdit: TEdit;
    TabSheet1: TTabSheet;
    ListData: TMemo;
    ListClear: TButton;
    Label31: TLabel;
    def_DACSetEdit: TEdit;
    wdg_DACSetEdit: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure readBtnClick(Sender: TObject);
    procedure writeBtnClick(Sender: TObject);
    procedure ReadUSRClick(Sender: TObject);
    procedure ReadDEFRawClick(Sender: TObject);
    procedure ListClearClick(Sender: TObject);
    procedure WriteButtonClick(Sender: TObject);
    procedure WriteDataEditChange(Sender: TObject);
    procedure ReadButtonClick(Sender: TObject);
    procedure RestoreTimeTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure ListScrollEndClick(Sender: TObject);
    procedure SetDefaultsClick(Sender: TObject);
    procedure RestoreDefaultsClick(Sender: TObject);
    procedure WatchdogVRClick(Sender: TObject);
    procedure WatchdogEEPROMVRClick(Sender: TObject);
    procedure pnpTimerTimer(Sender: TObject);
    procedure dioVRClick(Sender: TObject);
    procedure DIOConfigVRClick(Sender: TObject);
    procedure StartOutputFrequencyClick(Sender: TObject);
    procedure ctrModeLostClick(Sender: TObject);
    procedure ctrModeOnlyClick(Sender: TObject);
    procedure daqTimerTimer(Sender: TObject);
    procedure latchBtnClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure pwmSetCountButtonClick(Sender: TObject);
    procedure pwmConfigButtonCick(Sender: TObject);
    procedure dioCBClick(Sender: TObject);
    procedure ReadPNPClick(Sender: TObject);
    procedure mapSetCountButtonClick(Sender: TObject);
    procedure mapConfigButtonClick(Sender: TObject);
    procedure wdgButtonClick(Sender: TObject);
    procedure defButtonClick(Sender: TObject);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    diocount:LongWord;
    ctrcount:LongWord;
    pnp_REVMIN:byte;
    pnp_REVMAJ:byte;
    pnp_ADCSET:byte;
    pnp_DIOCon:byte;
    pnp_DIOBYT:byte;
    pnp_CTRNUM:byte;
    pnp_DACNUM:byte;
    pnp_LATCH:byte;
    pnp_DEB:byte;
    pnp_PWMMAX:byte;
    pnp_MAPMAX:byte;
    pnp_MAPSRC:byte;
    pnp_MAPDST:byte;
    PNP_Known:BOOL;
    MapRow: array of TECEPanel;
    PWMRow: array of TPWMPanel;
    DEF_8254Row: array of T_8254Panel;
    DEF_ADCSetConfig: array of TEdit;
    DEF_DIOCon: array of TEdit;
    DEF_DIOBytes: array of TEdit;
    DEF_DACWords: array of TEdit;
    DEF_DACSetRange: byte;

    WDG_8254Row: array of T_8254Panel;
    WDG_ADCSetConfig: array of TEdit;
    WDG_DIOCon: array of TEdit;
    WDG_DIOBytes: array of TEdit;
    WDG_DACWords: array of TEdit;
    WDG_DACSetRange: byte;

    procedure DoDynamicControls();
    function HexBytesToString(a: Longword; s:Longword; data: array of byte): string;
    procedure ReadAndParseDEF;

  public
     function ReadEEPROM( addr:Word; var size:LongWord; data:Pointer ): LongWord;
     procedure DumpEEPROMData( a: LongWord; tablename:string; flagLengthed:boolean; s:Longword );
     procedure DisplayHint(Sender: TObject);
     function HandleStatus( Status: LongWord ): LongWord;
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses
  Registry, AIOUSB;

{$R *.DFM}



const
  SetKey = 'Software\ACCES\USBFirmware2.0_ETest\1.0\';

procedure TMainForm.DisplayHint( Sender: TObject );
begin
  StatusBar1.SimpleText := GetLongHint(Application.Hint);
end;

function TMainForm.ReadEEPROM( addr:Word; var size:LongWord; data:Pointer ): LongWord;
begin
     Result := GenericVendorRead( diOnly, $A2, addr, addr, size, data );
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  Reg: TRegistry;
  Buf: String;

begin
    ctrPanel.ParentFont := False;
    ctrPanel.Font.Color := $00888888;

    Application.OnHint := DisplayHint;
    docMemo.ScrollBars := ssVertical;


    if QueryDeviceInfo(diOnly, nil, nil, nil, nil, nil) <> ERROR_SUCCESS then
    begin
        MessageBox(0, 'This program requires exactly one ACCES USB device be attached to the computer',
                    'ERROR', MB_OK or MB_ICONEXCLAMATION);
    end;

    Reg := TRegistry.Create(KEY_QUERY_VALUE);
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    if Reg.OpenKey(SetKey, False) then begin
      if Reg.ValueExists('Request') then ReqEdit.Text := IntToHex(Reg.ReadInteger('Request'), 2);
      if Reg.ValueExists('Value') then ValueEdit.Text := IntToHex(Reg.ReadInteger('Value'), 4);
      if Reg.ValueExists('Index') then IndexEdit.Text := IntToHex(Reg.ReadInteger('Index'), 4);
      if Reg.ValueExists('WriteData') then begin
        WriteDataEdit.Text := Reg.ReadString('WriteData');
        WriteDataEditChange(WriteDataEdit);
      end;
      if Reg.ValueExists('ReadLen') then ReadLenEdit.Text := IntToHex(Reg.ReadInteger('ReadLen'), 1);
      Buf := Reg.ReadString('LastDir');
      if Buf = 'I' then
        ReadButton.Default := True
      else if Buf = 'O' then
        WriteButton.Default := True
      ;
      if Reg.ValueExists('Autosave') then AutosaveCheck.Checked := Reg.ReadInteger('Autosave') <> 0;
    end;
    Reg.Free;
end;

procedure TMainForm.pnpTimerTimer(Sender: TObject);
var
    msg:string;
    Status:LongWord;
    m:LongWord;
    ID:Word;
    nSize:Longword;
    name:String;
    data : LongWord;
    size : LongWord;
    buf : array[0..3] of byte;

begin
    if pnpTimer.tag <> 0 then
    begin
        m := GetDevices;
        if m = 0 then pnpMemo.Clear;
        nSize := 255;
        SetString(Name, nil, 256);
        Status := QueryDeviceInfo( diOnly, @ID, @nSize, PChar(name), @diocount, @ctrcount );
        SetLength( name, nSize );
        if Status <> 0 then begin
            pnpMemo.Lines.Add('Error: ' + IntToStr(Status)+ ' on trying to use diOnly');
            pnpMemo.Lines.Add('GetDevices returned ' + IntToHex(m, 8));
            ClearDevices();
            pnpTimer.tag := 1;
            exit;
        end;

        size := 2;
        ReadEEPROM( 3, size, @data );
        msg := '['+IntToHex(ID, 4) + '] ' + name + ' [' + IntToHex(data, 4) + ']' + #13; // display the PID that's in the EEPROM
        size := 3;
        Status := GenericVendorRead( diOnly, $A3, $8000, $0001, size, @buf );
        pnpTimer.Tag := Status;
        if (buf[0] = 3) and (buf[2] = 3) then begin
            msg := msg + 'Firmware 2.0 detected' + #13;
            if ctrcount <> 0 then
            begin
                msg := msg + IntToHex(ctrcount, 2) + ' Counter Blocks';
                if diocount <> 0 then
                    msg := msg + ' and ';
                ctrPanel.ParentFont := True;
                ctrPanel.Enabled := True;
            end
                else begin ctrPanel.ParentFont := False; ctrPanel.Enabled := True; end;
            if diocount <> 0 then msg := msg + IntToHex(diocount,2) + ' DIO Bytes';
            pnpTimer.tag := 0;
        end else begin
            msg := msg + 'incompatible firmware detected /@8000 = ' + IntToHex(buf[0],2) + ' ' + IntToHex(buf[1],2) + ' ' + IntToHex(buf[2],2) + '/' + #13;
            msg := msg + 'do not use most of this program or you''ll experience lockups and other errors.';
            pnpTimer.tag := 1;
        end;

        pnpMemo.Lines.text := msg;
    end;
end;

procedure TMainForm.writeBtnClick(Sender: TObject);
var
address : LongWord;
data : LongWord;
  Status: LongWord;

begin
    address := StrToIntDef('$' + addrEdit.Text, $200);

    data := StrToIntDef('$' + dataEdit.Text, $100);

    if data > $ff then exit;

    Status :=HandleStatus(  GenericVendorWrite( diOnly, $A2, address, address, 1, @data ) );
    pnpTimer.tag := Status;
    if Status = ERROR_SUCCESS then
        ListData.Lines.Add('0x' + IntToHex(address, 4) + ' < ' + IntToHex(data, 2));
end;

procedure TMainForm.readBtnClick(Sender: TObject);
var
    address : Word;
    data : LongWord;
    size : LongWord;
begin
    address := StrToIntDef('$' + addrEdit.Text, $1FFF);
    size := 1;
    HandleStatus( ReadEEPROM(address, size, @data) );
    ListData.Lines.Add('0x' +IntToHex(address,4) + ': ' + IntToHex(data, 2));
end;

procedure TMainForm.ListClearClick(Sender: TObject);
begin
    ListData.Clear;
end;


function ErrorText(ErrorCode: LongWord): String;
var
  WindowsError: PChar;

begin
  FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER + FORMAT_MESSAGE_FROM_SYSTEM, nil, ErrorCode, 0, PChar(@WindowsError), 0, nil);
  Result := WindowsError;
  LocalFree(Cardinal(WindowsError));
end;

function NybbleToHex(N: Byte): Char;
begin
  N := N and $F;
  if N < 10 then
    Result := Char(Byte('0') + N)
  else
    Result := Char(Byte('A') - 10 + N)
  ;
end;

function StrToHex(Text: String): String;
var
  I: Integer;

begin
  SetString(Result, nil, Length(Text) * 2);
  for I := 1 to Length(Text) do begin
    Result[I * 2 - 1] := NybbleToHex(Byte(Text[I]) shr 4);
    Result[I * 2]     := NybbleToHex(Byte(Text[I])      );
  end;
end;

function StrToSpacedHex(Text: String): String;
var
  I: Integer;

begin
  SetString(Result, nil, Length(Text) * 3);
  for I := 1 to Length(Text) do begin
    Result[I * 3 - 2] := ' ';
    Result[I * 3 - 1] := NybbleToHex(Byte(Text[I]) shr 4);
    Result[I * 3]     := NybbleToHex(Byte(Text[I])      );
  end;
end;

function StringReplaceC(const S: String; const OldChar, NewChar: Char): String;
var
  I: Integer;

begin
  Result := S;
  for I := 1 to Length(Result) do
    if Result[I] = OldChar then
      Result[I] := NewChar
  ;
end;

function ValidateHexText(S: String): String;
var
  Content: TStringList;
  Buf: String;
  I, L: Integer;

begin
  S := StringReplaceC(S, ',', #13);
  S := StringReplaceC(S, ' ', #13);
  Content := TStringList.Create;
  try
    Content.Text := S;
    S := '';
    for I := Content.Count - 1 downto 0 do //Clear blank bytes and double delimiters
      if Length(Content[I]) = 0 then
        Content.Delete(I)
    ;
    L := Content.Count;
    SetString(Result, nil, L);
    for I := 0 to L - 1 do begin
      Buf := Content[I];
      Result[I + 1] := Char(StrToInt('$' + Buf));
    end;
  finally
    Content.Free;
  end;
end;

procedure TMainForm.WriteDataEditChange(Sender: TObject);
begin
  try
    WriteLenLabel.Caption := IntToStr(Length(ValidateHexText(WriteDataEdit.Text)));
    WriteDataEdit.Color := clWindow;
    WriteDataEdit.Font.Color := clWindowText;
  except
    WriteLenLabel.Caption := '';
    WriteDataEdit.Color := $0000FF;
    WriteDataEdit.Font.Color := $FFFFFF;
  end;
end;

procedure TMainForm.WriteButtonClick(Sender: TObject);
var
  I: LongWord;
  Buf: String;
  Status: LongWord;

begin
  I := diOnly;

  ReadButton.Default := False;
  WriteButton.Default := True;

  Buf := ValidateHexText(WriteDataEdit.Text);
  Status :=HandleStatus(  GenericVendorWrite(I, StrToInt('$' + ReqEdit.Text), StrToInt('$' + ValueEdit.Text), StrToInt('$' + IndexEdit.Text), Length(Buf), PChar(Buf)) );
  pnpTimer.tag := Status;
  if Status = ERROR_SUCCESS then begin
    SuccLabel.Caption := '';
    SuccLabel.Color := $00FF00;
  end
  else begin
    SuccLabel.Caption := IntToStr(Status) + ': ' + Trim(ErrorText(Status));
    SuccLabel.Color := $0000FF;
  end;
  RestoreTime.Enabled := True;
  Buf := '';
end;

procedure TMainForm.ReadButtonClick(Sender: TObject);
var
  I: LongWord;
  Buf: String;
  L: LongWord;
  Status: LongWord;

begin
  I := diOnly;

  WriteButton.Default := False;
  ReadButton.Default := True;

  L := StrToInt(ReadLenEdit.Text);
  SetString(Buf, nil, L);
  Status := HandleStatus(  GenericVendorRead(I, StrToInt('$' + ReqEdit.Text), StrToInt('$' + ValueEdit.Text), StrToInt('$' + IndexEdit.Text), L, PChar(Buf)) );
  pnpTimer.tag := Status;  
  if Status = ERROR_SUCCESS then begin
    SetLength(Buf, L);
    ReadDataEdit.Text := Trim(StrToSpacedHex(Buf));
    ReadLenEdit.Text := IntToStr(L);
  end
  else begin
    SuccLabel.Caption := IntToStr(Status) + ': ' + Trim(ErrorText(Status));
    SuccLabel.Color := $0000FF;
  end;
  RestoreTime.Enabled := True;
  Buf := '';
end;

procedure TMainForm.RestoreTimeTimer(Sender: TObject);
begin
  RestoreTime.Enabled := False;
  SuccLabel.ParentColor := True;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;


procedure TMainForm.FormDestroy(Sender: TObject);
var
  Reg: TRegistry;

begin
  if AutosaveCheck.Checked then SaveButton.Click else begin
    Reg := TRegistry.Create(KEY_SET_VALUE);
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    if Reg.OpenKey(SetKey, True) then begin
      try Reg.WriteBool('Autosave', AutosaveCheck.Checked); except end;
    end;
    Reg.Free;
  end;
end;

procedure TMainForm.SaveButtonClick(Sender: TObject);
var
  Reg: TRegistry;

begin
  Reg := TRegistry.Create(KEY_SET_VALUE);
  Reg.RootKey := HKEY_LOCAL_MACHINE;
  if Reg.OpenKey(SetKey, True) then begin
    try Reg.WriteInteger('Request', StrToInt('$' + ReqEdit.Text)); except end;
    try Reg.WriteInteger('Value', StrToInt('$' + ValueEdit.Text)); except end;
    try Reg.WriteInteger('Index', StrToInt('$' + IndexEdit.Text)); except end;
    try Reg.WriteString('WriteData', WriteDataEdit.Text); except end;
    try Reg.WriteInteger('ReadLen', StrToInt('$' + ReadLenEdit.Text)); except end;
    try
      if ReadButton.Default then
        Reg.WriteString('LastDir', 'I')
      else if WriteButton.Default then
        Reg.WriteString('LastDir', 'O')
      ;
    except
    end;
    try Reg.WriteBool('Autosave', AutosaveCheck.Checked); except end;
  end;
  Reg.Free;
end;


procedure TMainForm.ListScrollEndClick(Sender: TObject);
begin
//    ListData.ItemIndex := ListData.Items.Count -1;
//    ListData.ItemIndex := -1;
end;

function TMainForm.HexBytesToString( a:Longword; s:Longword; data:array of byte):string;
var
    i,j:word;
    msg:string;
begin
    i := 0;
    repeat
        msg := '0x' + IntToHex(a+i, 4) + ': ';
        for j := 0 to 15 do begin
             if ((i+j) >= s) then
                 continue;
             msg := msg + IntToHex(data[i+j], 2) + ' ';
        end; // j
        result := result + msg + #13+#10;
        i := i + 16;
    until i >= s;
end;

procedure TMainForm.DumpEEPROMData( a: LongWord; tablename:string; flagLengthed:boolean; s:Longword );
var
    i, j, size:LongWord;
    data:array [0..255] of Byte;
    msg:string;
begin
    if ListData.Lines.Count > 0 then if (ListData.Lines.Strings[ListData.Lines.Count-1] <> '') then ListData.Lines.Add('');

    if (flagLengthed) then begin
        size := $1;
        if (HandleStatus(ReadEEPROM( a, size, @data )) <> ERROR_SUCCESS) then exit;
        if data[0] = $FF then data[0] := 0;
        size := data[0];
    end
    else
        size := s;

    if size > 0 then begin
        if (flagLengthed) then inc(size);
        if (HandleStatus(ReadEEPROM( a, size, @data )) <> ERROR_SUCCESS) then exit;

        ListData.Lines.Add( HexBytesToString(a, size, data) );
    end else begin
        ListData.Lines.Add('The '+tablename+' table is empty');
    end;

    if (ListData.Lines.Strings[ListData.Lines.Count-1] <> '') then ListData.Lines.Add('');

end;



function TMainForm.HandleStatus( Status: LongWord ): LongWord;
begin
    pnpTimer.tag := Status;
    if Status = ERROR_SUCCESS then begin
        SuccLabel.Caption := '';
        SuccLabel.Color := $00FF00;
    end
    else begin
        SuccLabel.Caption := IntToStr(Status) + ': ' + Trim(ErrorText(Status));
        SuccLabel.Color := $0000FF;
    end;
    RestoreTime.Enabled := True;
    Result := Status;
end;

function byteArrayToBinary( bp:array of byte; c:integer):string;
var
  i:integer;
  b:byte;
begin
    for i := 1 to c do begin
        b := bp[i-1];
        result := IntToHex(b, 2) + ' ' + result;
    end;
end;


function CTR8254ArrayToBinary( wp:array of Word; c:integer):string;
var
  i:integer;
  w:Word;
begin
    result := '        ctr0 ctr1 ctr2' + #13;
    for i := 0 to c-1 do begin
        result := result + 'block '+IntToStr(i)+': ';
        w := wp[i*3];
        result := result + IntToHex(w, 4) + ' ';
        w := wp[i*3+1];
        result := result + IntToHex(w, 4) + ' ';
        w := wp[i*3+2];
        result := result + IntToHex(w, 4) + ' ';
        result := result + #13;
    end;

end;


procedure TMainForm.daqTimerTimer(Sender: TObject);
var
    Buf:array[0..80] of Byte;
    Wuf:array[0..14] of Word;
    l:LongWord;
begin
    if (dioCB.checked) then begin
        DIO_ReadAll(diOnly, @Buf[0]);
        dioLabel.caption := byteArrayToBinary( Buf, pnp_DIOBYT ) + ' Raw  ' ;

        if (ltchCB.checked) then begin
            l := dioCount *3;
            GenericVendorRead( diOnly, $14, $0000, $0000, l, @buf );
            dioLabel.caption := dioLabel.caption+#13+#10+
                                  byteArrayToBinary( Buf, dioCount )+' L Raw'+#13+#10+
                                  byteArrayToBinary( Buf[dioCount], dioCount )+' L Low'+#13+#10+
                                  byteArrayToBinary( Buf[dioCount*2], dioCount )+' L Hi ';
        end;
        if (debCB.checked) then begin
            l := dioCount;
            GenericVendorRead( diOnly, $15, $0000, $0000, l, @buf );
            dioLabel.caption := dioLabel.caption+#13+#10+byteArrayToBinary( Buf, dioCount )+' DEB  ';
        end;
    end;

    if (ctrCB.checked) then begin
        Fillchar(Wuf[0], 15*2, 0);
        HandleStatus(CTR_8254ReadAll(diOnly, @Wuf[0]));
        ctrLabel.caption := CTR8254ArrayToBinary( Wuf, ctrCount );
    end;
end;

procedure TMainForm.ReadUSRClick(Sender: TObject);
begin
    DumpEEPROMData( $1E00, 'USER', FALSE, $20 );
end;

procedure TMainForm.ReadAndParseDEF;
var
    i:integer;
    j, k, size:LongWord;
    data:array [0..255] of Byte;
    msg:string;
    globaltickdivisor:word;
    WDGtimeout:word;
    debtick:byte;
    latchtick:byte;
    debreload:byte;
    pwmtick:byte;
    pwmcount:byte;
    mapcount:byte;
    maptick:byte;
    globaltickenabled:byte;
    src,dst,duty:byte;
    inverted:BOOL;
begin
    if not PNP_Known then
        exit;
    if ListData.Lines.Count > 0 then if (ListData.Lines.Strings[ListData.Lines.Count-1] <> '') then ListData.Lines.Add('');

    size := $1;
    if (HandleStatus(GenericVendorRead( diOnly, $3C, 0, 0, size, @data)) <> ERROR_SUCCESS) then exit;
    if data[0] = $FF then data[0] := 0;
    size := data[0];

    if size > 0 then begin
        inc(size);
        if (HandleStatus(GenericVendorRead( diOnly, $3C, 0, 0, size, @data)) <> ERROR_SUCCESS) then exit;
        //display revision
        ListData.Lines.Add('Revision:               '+IntToHex(data[1], 2)+'.'+IntToHex(data[0], 2));  // major then minor revision
        globaltickdivisor := data[2] + (data[3] shl 8);
        globalTickEdit.text := IntToHex(globaltickdivisor, 4);

        if globaltickdivisor <> 0 then
            ListData.Lines.Add('Global Tick Divisor:    '+IntToHex(globaltickdivisor, 4)+'   ('+FloatToStr(12000000.0/(65535-globaltickdivisor))+' Hz)')
        else
            ListData.Lines.Add('Global Tick Divisor:    Disabled');

        WDGtimeout := data[4]+(data[5] shl 8);
        wdgSecondsEdit.text := IntToHex(WDGtimeout, 4);
        if WDGtimeout <> 0 then
            ListData.Lines.Add('Watchdog Timeout:      '+IntToHex(WDGtimeout, 4)+' '+InttoStr(WDGtimeout)+' Seconds')
        else
            ListData.Lines.Add('Watchdog Timeout:       Disabled');

        debtick := data[6];
        debTickEdit.text := IntToHex(debtick,2);
        ListData.Lines.Add('DEB Tick Divisor:       '+IntToHex(debtick,2));
        debreload := data[7];
        debTimeEdit.text := IntToHex(debreload,2);

        ListData.Lines.Add('DEB Time Constant:      '+IntToHex(debtick,2));
        if globaltickdivisor <> 0 then
            if debtick <> 0 then
                if debreload <> 0 then
                    ListData.Lines.Add('DEB Time Constant:      '+FloatToStr(12000000.0 / globaltickdivisor / debtick / debreload) + ' Seconds')
        ;
        latchtick := data[8];
        latchEdit.text := IntToHex(latchtick,2);
        ListData.Lines.Add('LATCH Tick Divisor:     '+IntToHex(latchtick,2));

        k:=9;
        pwmtick := data[k];
        inc(k);
        ListData.Lines.Add('PWM Tick Divisor:       '+IntToHex(pwmtick, 2));
        pwmTickEdit.text := IntToStr(pwmtick);
        for i:= 0 to PNP_PWMMAX-1 do begin
            dst := data[k+i*2];
            duty := data[k+i*2+1];
            inverted:=dst AND $80 = $80;
            dst := dst AND $7F;
            PWMRow[i].BitEdit.text := InttoStr(dst);
            PWMRow[i].DutyEdit.text := IntToStr(duty);
            PWMRow[i].InvCheck.checked := inverted;
            ListData.Lines.Add('PWM['+IntToHex(i,2)+'] = bit index '+IntToHex(dst,2) + ' @ ' + IntToHex(duty,2) + ' ticks, start = '+IntToStr(ord(inverted)+1));
        end;
        k := k + (PNP_PWMMAX)*2;
        pwmcount := data[k];
        ListData.Lines.Add('PWM Active Count:       '+IntToHex(pwmcount,2));
        pwmCountEdit.text := IntToStr(pwmcount);

        inc(k);
        maptick := data[k];
        ListData.Lines.Add('MAP Tick Divisor:       '+InttoHex(maptick,2));
        MapTickEdit.text := IntToStr(maptick);
        inc(k);
        for i:= 0 to PNP_MAPMAX-1 do begin
            src := data[k+i*2];
            dst := data[k+i*2+1];
            inverted := dst AND $80 = $80;
            dst := dst AND $7F;
            MAPRow[i].SrcEdit.text := InttoStr(src);
            MAPRow[i].DstEdit.text := IntToStr(dst);
            MAPRow[i].InvCheck.checked := inverted;

            ListData.Lines.Add('MAP['+IntToHex(i,2)+'] = ( '+IntToHex(src,2) + ', ' + IntToHex(dst,2) + ' ) inverted = '+IntToStr(ord(inverted)+1));
        end;
        k:=k+(PNP_MAPMAX)*2;
        mapcount := data[k];
        inc(k);
        ListData.Lines.Add('MAP Active Count:      '+IntToHex(mapcount,2));
        mapCountEdit.text := IntToStr(mapcount);

        // DEF IO_STRUCT
        for I := 0 to pnp_ADCSET-1 do begin
            DEF_ADCSetConfig[I].Text := IntToHex(data[k],2);inc(k);
        end;

        for I := 0 to pnp_DIOCon-1 do begin
            DEF_DIOCon[I].Text := IntToHex(data[k],2);inc(k);
        end;

        for I := 0 to pnp_DIOBYT-1 do begin
            DEF_DIOBytes[I].Text := IntToHex(data[k],2);inc(k);
        end;

        for I := 0 to pnp_CTRNUM-1 do begin
            for j:= 0 to 2 do begin
                DEF_8254Row[I].ctr[j].ModeList.ItemIndex := ((data[k] div 2) and $7);inc(k);
                DEF_8254Row[I].ctr[j].LoadCheck.checked := data[k]<>0;inc(k);
                DEF_8254Row[I].ctr[j].LoadEdit.Text := IntToHex(data[k]+data[k+1]*256,4);inc(k,2);
            end;
        end;

        if pnp_DACNum >0 then begin
          for I := 0 to pnp_DACNUM-1 do
             DEF_DACWords[I].Text := IntToHex(data[k]+data[k+1]*256,4);inc(k,2);
          def_DACSetEdit.text := IntToHex(data[k],2);
          inc(k);
        end;

        // WDG IO_STRUCT
        for I := 0 to pnp_ADCSET-1 do begin
            WDG_ADCSetConfig[I].Text := IntToHex(data[k],2);inc(k);
        end;

        for I := 0 to pnp_DIOCon-1 do begin
            WDG_DIOCon[I].Text := IntToHex(data[k],2);inc(k);
        end;

        for I := 0 to pnp_DIOBYT-1 do begin
            WDG_DIOBytes[I].Text := IntToHex(data[k],2);inc(k);
        end;

        for I := 0 to pnp_CTRNUM-1 do begin
            for j:= 0 to 2 do begin
                WDG_8254Row[I].ctr[j].ModeList.ItemIndex := ((data[k] div 2) and $7);inc(k);
                WDG_8254Row[I].ctr[j].LoadCheck.checked := data[k]<>0;inc(k);
                WDG_8254Row[I].ctr[j].LoadEdit.Text := IntToHex(data[k]+data[k+1]*256,4);inc(k,2);
            end;
        end;

        if pnp_DACNum >0 then begin
          for I := 0 to pnp_DACNUM-1 do
              WDG_DACWords[I].Text := IntToHex(data[k]+data[k+1]*256,4);inc(k,2);

          wdg_DACSetEdit.text := IntToHex(data[k],2);
          inc(k);
        end;
        ListData.Lines.Add('parsed DEFBuf data amounted to '+IntToHex(k,2)+' Bytes. Confirm first byte of RAW DEF matches...');
    end;

end;

procedure TMainForm.ReadDEFRawClick(Sender: TObject);
begin
    DumpEEPROMData($1F00, 'DEF', TRUE, 0 )
end;



procedure TMainForm.SetDefaultsClick(Sender: TObject);
begin
    HandleStatus( GenericVendorWrite(diOnly, $3C, $ACCE, $0010, 0, nil) );
end;

procedure TMainForm.RestoreDefaultsClick(Sender: TObject);
begin
    HandleStatus( GenericVendorWrite(diOnly, $3C, $ACCE, $0011, 0, nil) );
end;

procedure TMainForm.WatchdogVRClick(Sender: TObject);
var
    msg:string;
    i:integer;
    s:LongWord;
    buf:byte;
begin
    s := 1;
    ReadEEPROM( $1D80, s, @buf );
    s := buf;

    ReqEdit.Text := '2E';    
    ValueEdit.Text := '0000';
    IndexEdit.Text := '0000';
    msg := '';
    for i := 1 to s do begin
        msg := msg + '00 ';
    end;

    WriteDataEdit.Text := msg;

    ReadLenEdit.Text := IntToStr( s+3 );

    WriteButton.SetFocus;
end;

procedure TMainForm.WatchdogEEPROMVRClick(Sender: TObject);
var
    msg:string;
    i:integer;
    s:LongWord;
    buf:byte;
begin
    s := 1;
    ReadEEPROM( $1D80, s, @buf );
    s := buf;

    ReqEdit.Text := '2E';
    ValueEdit.Text := '0001';
    IndexEdit.Text := '0001';
    msg := '';
    for i := 1 to s do begin
        msg := msg + '00 ';
    end;

    WriteDataEdit.Text := msg;

    ReadLenEdit.Text := IntToStr( s+3 );

    WriteButton.SetFocus;
end;

procedure TMainForm.dioVRClick(Sender: TObject);
var
    msg:string;
    i:integer;
    s:LongWord;
begin
    s := diocount;
    ReqEdit.Text := '10';
    ValueEdit.Text := '0000';
    IndexEdit.Text := '0000';
    msg := '';
    for i := 1 to s do begin
        msg := msg + '00 ';
    end;

    WriteDataEdit.Text := msg;
    ReadLenEdit.Text := IntToStr( s );
    ReadButton.SetFocus;
end;

procedure TMainForm.DIOConfigVRClick(Sender: TObject);
var
    msg:string;
    i:integer;
    s:LongWord;
begin
    s := diocount+1;
    ReqEdit.Text := '12';
    ValueEdit.Text := '0000';
    IndexEdit.Text := '0000';
    msg := '';
    for i := 1 to s do begin
        msg := msg + '00 ';
    end;

    WriteDataEdit.Text := msg;
    ReadLenEdit.Text := IntToStr( s );
    WriteButton.SetFocus;
end;


procedure TMainForm.StartOutputFrequencyClick(Sender: TObject);
var
    f:double;
    Status:LongWord;
begin
    f := StrToFloat( FreqEdit.text );
    Status := HandleStatus( CTR_StartOutputFreq( diOnly, StrToInt(ctrBlockEdit.Text), @f) );
    if Status = ERROR_SUCCESS then begin
        actualFreqEdit.Text := FloatToStr(f);
    end
    else begin
        actualFreqEdit.Text := '';
    end;
end;

procedure TMainForm.ctrModeLostClick(Sender: TObject);
var
    m : byte;

begin
    m := (StrToInt(ctrEdit.Text) shl 6) OR $30 OR (StrToInt(ctrModeEdit.text) shl 1);
    HandleStatus( CTR_8254ModeLoad( diOnly, StrToInt(ctrBlockEdit.Text), StrToInt(ctrEdit.Text), m, StrToInt('$'+ctrLoadEdit.Text) ) );

end;

procedure TMainForm.ctrModeOnlyClick(Sender: TObject);
var
    m : byte;
begin
    m := (StrToInt(ctrEdit.Text) shl 6) OR $30 OR (StrToInt(ctrModeEdit.text) shl 1);
    HandleStatus( CTR_8254Mode( diOnly, StrToInt(ctrBlockEdit.Text), StrToInt(ctrEdit.Text), m )) ;
end;


procedure TMainForm.latchBtnClick(Sender: TObject);
var tdiv:byte;
begin
    tdiv :=  StrToInt('$'+latchEdit.Text);
    HandleStatus( GenericVendorWrite( diOnly, $3C, $0000, $0061, 1, @tdiv )) ;
end;

procedure TMainForm.Button1Click(Sender: TObject);
var
    b:array[0..1] of byte;
begin
    b[0] :=  StrToInt('$'+debTickEdit.Text);
    b[1] :=  StrToInt('$'+debTimeEdit.Text);
    HandleStatus( GenericVendorWrite( diOnly, $3C, $0000, $0051, 2, @b )) ;
end;

procedure TMainForm.Button2Click(Sender: TObject);
var gdiv:word;
begin
    gdiv :=  StrToInt('$'+globalTickEdit.Text);
    HandleStatus( GenericVendorWrite( diOnly, $3C, gdiv, $8001, 0, nil )) ;

end;

procedure TMainForm.pwmSetCountButtonClick(Sender: TObject);
var tick:byte;
begin
    tick := StrToInt(pwmTickEdit.text);
    HandleStatus( GenericVendorWrite( diOnly, $3C, $0000, $0073, 1, @tick )) ;
end;

procedure TMainForm.pwmConfigButtonCick(Sender: TObject);
TYPE
   pwm_struct_type = packed record
      TickDivisor:byte;
      PWM: array[0..7] of packed record
             BitIndex:byte;
             DutyCycleReload:byte;
      end;
      Count:byte;
   end;

VAR
   pwm:pwm_struct_type;
   i:byte;

begin
    pwmDebugMemo.Clear;

    pwm.TickDivisor := StrToInt(pwmTickEdit.Text);
    for i := 0 to High(PWMRow) do with PWMRow[i] do begin
        pwm.pwm[i].BitIndex := StrToInt(BitEdit.text) or (ord(Invcheck.checked) * $80);
        pwm.pwm[i].DutyCycleReload := StrToInt(DutyEdit.Text);
        pwm.Count := StrToInt(pwmCountEdit.Text);
    end;

    pwmDebugMemo.Lines.Add(IntToStr(pwm.TickDivisor));
    for i := 0 to 7 do  begin
        pwmDebugMemo.Lines.Add(IntToHex(pwm.pwm[i].BitIndex, 2) + ' @ ' + IntToStr(pwm.pwm[i].DutyCycleReload));
    end;//i
    pwmDebugMemo.Lines.Add(IntToStr(pwm.Count));

    HandleStatus( GenericVendorWrite( diOnly, $3C, $0000, $0071, sizeof(pwm), @pwm )) ;
end;

procedure TMainForm.dioCBClick(Sender: TObject);
begin
    ltchCB.enabled := dioCB.checked;
    debCB.enabled := dioCB.checked;
end;

procedure TMainForm.ReadPNPClick(Sender: TObject);
var
    data:array [0..255] of Byte;
    size:Longword;
begin
    PNP_Known := False;
    if ListData.Lines.Count > 0 then if (ListData.Lines.Strings[ListData.Lines.Count-1] <> '') then ListData.Lines.Add('');

    size := $1;
    if (HandleStatus(GenericVendorRead( diOnly, $3F, 0, 0, size, @data)) <> ERROR_SUCCESS) then exit;
    if data[0] = $FF then data[0] := 0;
    size := data[0];

    if size > 0 then begin
        inc(size);
        if (HandleStatus(GenericVendorRead( diOnly, $3F, 0, 0, size, @data)) <> ERROR_SUCCESS) then exit;
        pnp_REVMIN := data[1];
        pnp_REVMAJ := data[2];
        pnp_ADCSET := data[3];
        pnp_DIOCon := data[4];
        pnp_DIOBYT := data[5];
        pnp_CTRNUM := data[6];
        pnp_DACNUM := data[7];
        pnp_LATCH := data[8];
        pnp_DEB := data[9];
        pnp_PWMMAX := data[10];
        pnp_MAPMAX := data[11];
        pnp_MAPSRC := data[12];
        pnp_MAPDST := data[13];

        ListData.Lines.Add('typedef struct /*IO_STRUCT_TYPE*/');
        ListData.Lines.Add('{');
        if pnp_ADCSET <> 0 then begin
            ListData.Lines.Add('    BYTE  adc['+IntToStr(pnp_ADCSET)+'];');
        end;
        if pnp_DIOCon <> 0 then begin
            ListData.Lines.Add('    BYTE  DIOCon['+IntToStr(pnp_DIOCon)+'];');
        end;
        if pnp_DIOBYT <> 0 then begin
            ListData.Lines.Add('    BYTE  dio['+IntToStr(pnp_DIOBYT)+'];');
        end;
        if pnp_CTRNUM <> 0 then begin
            ListData.Lines.Add('    _8254 CTR['+IntToStr(pnp_CTRNUM)+'];');
            ListData.Lines.Add('    // CTR[0-'+IntToStr(pnp_CTRNUM-1)+'].ctr[0-2].{BYTE mode, flagload, LSB, MSB}');
        end;
        if pnp_DACNUM <> 0 then begin
            ListData.Lines.Add('    WORD  dac['+IntToStr(pnp_DACNUM)+'];');
            ListData.Lines.Add('    BYTE  dacrange_refenabled;');
        end;
        ListData.Lines.Add('}');
        ListData.Lines.Add('');

        ListData.Lines.Add('Revision:              '+IntToHex(pnp_REVMAJ,2)+'.'+IntToHex(pnp_REVMIN,2));
//        ListData.Lines.Add('ADC SetConfig bytes    '+IntToHex(pnp_ADCSET,2));
//        ListData.Lines.Add('DIO Control bytes      '+IntToHex(pnp_DEF_DIOCon,2));
//        ListData.Lines.Add('DIO Bytes              '+IntToHex(pnp_DIOBYT,2));
//        ListData.Lines.Add('CTR 8254 count         '+IntToHex(pnp_CTRNUM,2));
//        ListData.Lines.Add('DAC Words              '+IntToHex(pnp_DACNUM,2));
        if pnp_LATCH = $FF then ListData.Lines.Add('Supports DEBounce   ') else ListData.Lines.Add('Does not support DEBounce');
        if pnp_DEB = $FF then ListData.Lines.Add('Supports LATCH   ') else ListData.Lines.Add('Does not support LATCH');
        ListData.Lines.Add('PWM MAX Channels       '+IntToHex(pnp_PWMMAX,2));
        ListData.Lines.Add('MAP MAX Operations     '+IntToHex(pnp_MAPMAX,2));
        ListData.Lines.Add('MAP MAX bit src idx    '+IntToHex(pnp_MAPSRC,2));
        ListData.Lines.Add('MAP MAX bit dst idx    '+IntToHex(pnp_MAPDST,2));
        PNP_Known := True;
    end else begin
        ListData.Lines.Add('The pnp table is empty');
    end;

    if (ListData.Lines.Strings[ListData.Lines.Count-1] <> '') then ListData.Lines.Add('');

    doDynamicControls;
    ReadAndParseDEF;
end;

procedure TMainForm.mapSetCountButtonClick(Sender: TObject);
var tick:byte;
begin
    tick := StrToInt(mapTickEdit.text);
    HandleStatus( GenericVendorWrite( diOnly, $3C, $0000, $0083, 1, @tick )) ;
end;

procedure TMainForm.mapConfigButtonClick(Sender: TObject);
TYPE
   map_struct_type = packed record
      TickDivisor:byte;
      MAP: array[0..31] of packed record
             SrcIndex:byte;
             DstIndex:byte;
      end;
      Count:byte;
   end;
VAR
   map:map_struct_type;
   i:byte;
begin
    mapDebugMemo.Clear;

    map.TickDivisor := StrToInt(mapTickEdit.Text);
    for i := 0 to High(mapRow) do with mapRow[i] do begin
        map.map[i].SrcIndex := StrToInt(SrcEdit.text);
        map.map[i].DstIndex := StrToInt(DstEdit.Text) or (ord(Invcheck.checked) * $80);
        map.Count := StrToInt(mapCountEdit.Text);
    end;

    mapDebugMemo.Lines.Add(IntToStr(map.TickDivisor));
    for i := 0 to 31 do  begin
        mapDebugMemo.Lines.Add(IntToHex(map.map[i].SrcIndex, 2) + ' -> ' + IntToStr(map.map[i].DstIndex));
    end;//i
    mapDebugMemo.Lines.Add(IntToStr(map.Count));

    HandleStatus( GenericVendorWrite( diOnly, $3C, $0000, $0081, sizeof(map), @map )) ;
end;

procedure TMainForm.DoDynamicControls;
var
  I, J: Integer;
  oL: Integer;

begin
    LockWindowUpdate(MainForm.Handle);

    //ADC SetConfig io struct stuff
    oL := Length(DEF_ADCSetConfig);
    for I := pnp_ADCSET to oL-1 do begin
      DEF_ADCSetConfig[I].Free;
      WDG_ADCSetConfig[I].Free;
    end;
    SetLength(DEF_ADCSetConfig, pnp_ADCSET);
    SetLength(WDG_ADCSetConfig, pnp_ADCSET);
    for I := oL to High(DEF_ADCSetConfig) do begin
        DEF_ADCSetConfig[I] := TEdit.Create(Self);
        DEF_ADCSetConfig[I].Parent := adcSB;
        DEF_ADCSetConfig[I].OnKeyPress := EditKeyPress;
        DEF_ADCSetConfig[I].SetBounds(3, 3+18*I, 40, 18);
        DEF_ADCSetConfig[I].text := '00';

        WDG_ADCSetConfig[I] := TEdit.Create(Self);
        WDG_ADCSetConfig[I].Parent := WDGadcSB;
        WDG_ADCSetConfig[I].SetBounds(3, 3+18*I, 40, 18);
        WDG_ADCSetConfig[I].text := '00';
    end;

    //DIO Control bytes io struct stuff
    if pnp_DIOCon <> 0 then begin
      iostructDIOConLabel.caption := 'DIO Control Bytes 0 through '+ IntToStr(pnp_DIOCon-1);
      WDGiostructDIOConLabel.caption := 'DIO Control Bytes 0 through '+ IntToStr(pnp_DIOCon-1);
    end;
    oL := Length(DEF_DIOCon);
    for I := pnp_DIOCon to oL-1 do begin
      DEF_DIOCon[I].Free;
      WDG_DIOCon[I].Free;
    end;
    SetLength(DEF_DIOCon, pnp_DIOCon);
    SetLength(WDG_DIOCon, pnp_DIOCon);
    for I := oL to High(DEF_DIOCon) do begin
        DEF_DIOCon[I] := TEdit.Create(Self);
        DEF_DIOCon[I].Parent := iostructGB;
        DEF_DIOCon[I].OnKeyPress := EditKeyPress;
        DEF_DIOCon[I].SetBounds(3+32*I, 32, 30, 18);
        DEF_DIOCon[I].text := '00';

        WDG_DIOCon[I] := TEdit.Create(Self);
        WDG_DIOCon[I].Parent := WDG_GB;
        WDG_DIOCon[I].SetBounds(3+32*I, 32, 30, 18);
        WDG_DIOCon[I].text := '00';
    end;

    //DIO bytes io struct stuff
    if pnp_DIOBYT <> 0 then begin
      iostructDIOBytesLabel.caption := 'DIO Bytes 0 through '+ IntToStr(pnp_DIOBYT-1);
      WDGiostructDIOBytesLabel.caption := 'DIO Bytes 0 through '+ IntToStr(pnp_DIOBYT-1);
    end;
    oL := Length(DEF_DIOBytes);
    for I := pnp_DIOBYT to oL-1 do begin
      DEF_DIOBytes[I].Free;
      WDG_DIOBytes[I].Free;
    end;
    SetLength(DEF_DIOBytes, pnp_DIOBYT);
    SetLength(WDG_DIOBytes, pnp_DIOBYT);
    for I := oL to High(DEF_DIOBytes) do begin
        DEF_DIOBytes[I] := TEdit.Create(Self);
        DEF_DIOBytes[I].OnKeyPress := EditKeyPress;
        DEF_DIOBytes[I].Parent := iostructGB;
        DEF_DIOBytes[I].SetBounds(3+32*I, 72, 30, 18);
        DEF_DIOBytes[I].text := '00';

        WDG_DIOBytes[I] := TEdit.Create(Self);
        WDG_DIOBytes[I].Parent := WDG_GB;
        WDG_DIOBytes[I].OnKeyPress := EditKeyPress;
        WDG_DIOBytes[I].SetBounds(3+32*I, 72, 30, 18);
        WDG_DIOBytes[I].text := '00';
    end;

    //8254 io struct stuff
    oL := Length(DEF_8254Row);
    for I := pnp_CTRNUM to oL-1 do begin
      DEF_8254Row[I].RowPanel.Free;
      WDG_8254Row[I].RowPanel.Free;
    end;
    SetLength(DEF_8254Row, pnp_CTRNUM);
    SetLength(WDG_8254Row, pnp_CTRNUM);
    for I := oL to High(DEF_8254Row) do begin
      with DEF_8254Row[I] do begin
        RowPanel := TPanel.Create(Self);
        RowPanel.Parent := _8254SB;
        RowPanel.BevelOuter := bvNone;
        RowPanel.SetBounds(0, 96 * I, 193, 96);
        RowPanel.Align := alTop;

        Msg1 := TLabel.Create(RowPanel);
        Msg1.Parent := RowPanel;
        Msg1.Align := alTop;
        Msg1.Caption := '8254 #'+IntToStr(I);

        for J := 0 to 2 do with ctr[J] do begin
          modeList := TComboBox.Create(RowPanel);
          modeList.Parent := RowPanel;
          modeList.Style := csDropDownList;
          modeList.SetBounds(3, 14+24*J, 41, 21);
          modeList.Items.Add( '0' );
          modeList.Items.Add( '1' );
          modeList.Items.Add( '2' );
          modeList.Items.Add( '3' );
          modeList.Items.Add( '4' );
          modeList.Items.Add( '5' );
          ModeList.itemindex := 0;

          LoadCheck := TCheckBox.Create(RowPanel);
          LoadCheck.Parent := RowPanel;
          LoadCheck.SetBounds(49, 15+24*J, 50, 21);
          LoadCheck.Caption := 'Load?';

          LoadEdit := TEdit.Create(RowPanel);
          LoadEdit.Parent := RowPanel;
          LoadEdit.OnKeyPress := EditKeyPress;
          LoadEdit.SetBounds(102, 12+24*J, 40, 18);
          LoadEdit.Text := '0000';
        end;
      end;//with DEF
      with WDG_8254Row[I] do begin
        RowPanel := TPanel.Create(Self);
        RowPanel.Parent := WDG_8254SB;
        RowPanel.BevelOuter := bvNone;
        RowPanel.SetBounds(0, 96 * I, 193, 96);
        RowPanel.Align := alTop;

        Msg1 := TLabel.Create(RowPanel);
        Msg1.Parent := RowPanel;
        Msg1.Align := alTop;
        Msg1.Caption := '8254 #'+IntToStr(I);

        for J := 0 to 2 do with ctr[J] do begin
          modeList := TComboBox.Create(RowPanel);
          modeList.Parent := RowPanel;
          modeList.Style := csDropDownList;
          modeList.SetBounds(3, 14+24*J, 41, 21);
          modeList.Items.Add( '0' );
          modeList.Items.Add( '1' );
          modeList.Items.Add( '2' );
          modeList.Items.Add( '3' );
          modeList.Items.Add( '4' );
          modeList.Items.Add( '5' );
          ModeList.itemindex := 0;

          LoadCheck := TCheckBox.Create(RowPanel);
          LoadCheck.Parent := RowPanel;
          LoadCheck.SetBounds(49, 15+24*J, 50, 21);
          LoadCheck.Caption := 'Load?';

          LoadEdit := TEdit.Create(RowPanel);
          LoadEdit.Parent := RowPanel;
          LoadEdit.OnKeyPress := EditKeyPress;
          LoadEdit.SetBounds(102, 12+24*J, 40, 18);
          LoadEdit.Text := '0000';
        end;
      end;//with DEF
    end;

    //DAC Words io struct stuff
    oL := Length(DEF_DACWords);
    for I := pnp_DACNUM to oL-1 do begin
      DEF_DACWords[I].Free;
      WDG_DACWords[I].Free;
    end;
    SetLength(DEF_DACWords, pnp_DACNUM);
    SetLength(WDG_DACWords, pnp_DACNUM);
    for I := oL to High(DEF_DACWords) do begin
        DEF_DACWords[I] := TEdit.Create(Self);
        DEF_DACWords[I].Parent := dacSB;
        DEF_DACWords[I].OnKeyPress := EditKeyPress;
        DEF_DACWords[I].SetBounds(3, 3+18*I, 40, 18);
        DEF_DACWords[I].text := '0000';

        WDG_DACWords[I] := TEdit.Create(Self);
        WDG_DACWords[I].Parent := WDGdacSB;
        WDG_DACWords[I].OnKeyPress := EditKeyPress;
        WDG_DACWords[I].SetBounds(3, 3+18*I, 40, 18);
        WDG_DACWords[I].text := '0000';
    end;

    oL := Length(PWMRow);
    for I := pnp_PWMMAX to oL-1 do
      PWMRow[I].RowPanel.Free
    ;
    SetLength(PWMRow, pnp_PWMMAX);
    for I := oL to High(PWMRow) do with PWMRow[I] do begin
      RowPanel := TPanel.Create(Self);
      RowPanel.Parent := pwmSB;
      RowPanel.BevelOuter := bvNone;
      RowPanel.SetBounds(0, 24 * I, 193, 24);
      RowPanel.Align := alTop;

      BitEdit := TEdit.Create(RowPanel);
      BitEdit.Parent := RowPanel;
      BitEdit.OnKeyPress := EditKeyPress;
      BitEdit.SetBounds(8, 8, 41, 21);
      BitEdit.Text := '0';

      InvCheck := TCheckBox.Create(RowPanel);
      InvCheck.Parent := RowPanel;
      InvCheck.SetBounds(72, 8, 25, 17);

      DutyEdit := TEdit.Create(RowPanel);
      DutyEdit.Parent := RowPanel;
      DutyEdit.OnKeyPress := EditKeyPress;
      DutyEdit.SetBounds(120, 8, 41, 21);
      DutyEdit.Text := '100';
    end;

    oL := Length(MapRow);
    for I := pnp_MAPMAX to oL-1 do
      MapRow[I].RowPanel.Free
    ;
    SetLength(MapRow, pnp_MAPMAX);
    for I := oL to High(MapRow) do with MapRow[I] do begin
      RowPanel := TPanel.Create(Self);
      RowPanel.Parent := mapSB;
      RowPanel.BevelOuter := bvNone;
      RowPanel.SetBounds(0, 24 * I, 193, 24);
      RowPanel.Align := alTop;

      SrcEdit := TEdit.Create(RowPanel);
      SrcEdit.Parent := RowPanel;
      SrcEdit.OnKeyPress := EditKeyPress;
      SrcEdit.SetBounds(8, 8, 41, 21);
      SrcEdit.Text := '0';

      InvCheck := TCheckBox.Create(RowPanel);
      InvCheck.Parent := RowPanel;
      InvCheck.SetBounds(72, 8, 25, 17);

      DstEdit := TEdit.Create(RowPanel);
      DstEdit.Parent := RowPanel;
      DstEdit.OnKeyPress := EditKeyPress;
      DstEdit.SetBounds(120, 8, 41, 21);
      DstEdit.Text := '100';
    end;
    LockWindowUpdate(HWND(nil));
end;

procedure TMainForm.wdgButtonClick(Sender: TObject);
var
  buf:array[0..254] of byte;
  i,j,k:integer;
  t:Longword;
begin
    k := 0;

    t := StrToInt('$'+wdgSecondsEdit.Text);
    buf[k] := t and $ff;
    inc(k);
    buf[k] := (t shr 8) and $ff;
    inc(k);

    for i := 0 to pnp_ADCSET-1 do begin
        buf[k] :=  StrToInt('$'+WDG_ADCSetConfig[i].text);
        inc(k);
    end;

    for i := 0 to pnp_DIOCon-1 do begin
        buf[k] :=  StrToInt('$'+WDG_DIOCon[i].text);
        inc(k);
    end;

    for i := 0 to pnp_DIOBYT-1 do begin
        buf[k] :=  StrToInt('$'+WDG_DIOBytes[i].text);
        inc(k);
    end;

    for i := 0 to pnp_CTRNUM-1 do with WDG_8254Row[I] do begin
        for j := 0 to 2 do with ctr[j] do begin
            buf[k] := (j shl 6) or $30 or (ModeList.ItemIndex shl 1);
            inc(k);
            buf[k] := ord(LoadCheck.checked);
            inc(k);
            t := StrToInt('$'+LoadEdit.Text);
            buf[k] := t and $ff;
            inc(k);
            buf[k] := (t shr 8) and $ff;
            inc(k);
        end;
    end;

    for i := 0 to pnp_DACNUM-1 do begin
            t := StrToInt('$'+WDG_DACWords[i].Text);
            buf[k] := t and $ff;
            inc(k);
            buf[k] := (t shr 8) and $ff;
            inc(k);
    end;
    if pnp_DACNUM <>0 then begin
        buf[k]:=StrToInt(wdg_DACSetEdit.text);
        inc(k);
    end;

    ListData.Lines.Add( HexBytesToString(0, k, buf) );
    HandleStatus( GenericVendorWrite( diOnly, $3C, 0, $0041, k, @buf ) );
end;

procedure TMainForm.defButtonClick(Sender: TObject);
var
  buf:array[0..254] of byte;
  i,j,k:integer;
  t:Longword;
begin
    k := 0;

    t := StrToInt('$'+GlobalTickEdit.Text);
    buf[k] := t and $ff;
    inc(k);
    buf[k] := (t shr 8) and $ff;
    inc(k);

    t := StrToInt('$'+wdgSecondsEdit.Text);
    buf[k] := t and $ff;
    inc(k);
    buf[k] := (t shr 8) and $ff;
    inc(k);

    buf[k] := StrToInt('$'+debTickEdit.text);
    inc(k);

    buf[k] := StrToInt('$'+debTimeEdit.text);
    inc(k);

    buf[k] := StrToInt('$'+latchEdit.text);
    inc(k);

    buf[k] := StrtoInt(pwmTickEdit.text);
    inc(k);
    for i := 0 to pnp_PWMMAX-1 do with PWMRow[i] do begin  // all numbers decimal at the moment!!! --J2H
        buf[k] := StrToInt(BitEdit.text);
        if InvCheck.checked then
            buf[k] := buf[k] OR $80;
        inc(k);
        buf[k] := StrtoInt(DutyEdit.text);
        inc(k);
    end;
    buf[k] := StrToInt(pwmCountEdit.text);
    inc(k);

    buf[k] := StrtoInt(mapTickEdit.text);
    inc(k);
    for i := 0 to pnp_MAPMAX-1 do with MAPRow[i] do begin  // all numbers decimal at the moment!!! --J2H
        buf[k] := StrToInt(SrcEdit.text);
        inc(k);
        buf[k] := StrToInt(DstEdit.text);
        if InvCheck.checked then
            buf[k] := buf[k] OR $80;
        inc(k);
    end;
    buf[k] := StrToInt(mapCountEdit.text);
    inc(k);

    // DEF IO STRUCT READING
    for i := 0 to pnp_ADCSET-1 do begin
        buf[k] :=  StrToInt('$'+DEF_ADCSetConfig[i].text);
        inc(k);
    end;

    for i := 0 to pnp_DIOCon-1 do begin
        buf[k] :=  StrToInt('$'+DEF_DIOCon[i].text);
        inc(k);
    end;

    for i := 0 to pnp_DIOBYT-1 do begin
        buf[k] :=  StrToInt('$'+DEF_DIOBytes[i].text);
        inc(k);
    end;

    for i := 0 to pnp_CTRNUM-1 do with DEF_8254Row[I] do begin
        for j := 0 to 2 do with ctr[j] do begin
            buf[k] := (j shl 6) or $30 or (ModeList.ItemIndex shl 1);
            inc(k);
            buf[k] := ord(LoadCheck.checked);
            inc(k);
            t := StrToInt('$'+LoadEdit.Text);
            buf[k] := t and $ff;
            inc(k);
            buf[k] := (t shr 8) and $ff;
            inc(k);
        end;
    end;

    for i := 0 to pnp_DACNUM-1 do begin
            t := StrToInt('$'+DEF_DACWords[i].Text);
            buf[k] := t and $ff;
            inc(k);
            buf[k] := (t shr 8) and $ff;
            inc(k);
    end;
    if pnp_DACNUM <>0 then begin
        buf[k]:=StrToInt('$'+def_DACSetEdit.text);
        inc(k);
    end;

    // WDG IO STRUCT READING
    for i := 0 to pnp_ADCSET-1 do begin
        buf[k] :=  StrToInt('$'+WDG_ADCSetConfig[i].text);
        inc(k);
    end;

    for i := 0 to pnp_DIOCon-1 do begin
        buf[k] :=  StrToInt('$'+WDG_DIOCon[i].text);
        inc(k);
    end;

    for i := 0 to pnp_DIOBYT-1 do begin
        buf[k] :=  StrToInt('$'+WDG_DIOBytes[i].text);
        inc(k);
    end;

    for i := 0 to pnp_CTRNUM-1 do with WDG_8254Row[I] do begin
        for j := 0 to 2 do with ctr[j] do begin
            buf[k] := (j shl 6) or $30 or (ModeList.ItemIndex shl 1);
            inc(k);
            buf[k] := ord( LoadCheck.checked);
            inc(k);
            t := StrToInt('$'+LoadEdit.Text);
            buf[k] := t and $ff;
            inc(k);
            buf[k] := (t shr 8) and $ff;
            inc(k);
        end;
    end;

    for i := 0 to pnp_DACNUM-1 do begin
            t := StrToInt('$'+WDG_DACWords[i].Text);
            buf[k] := t and $ff;
            inc(k);
            buf[k] := (t shr 8) and $ff;
            inc(k);
    end;
    if pnp_DACNUM <>0 then begin
        buf[k]:=StrToInt('$'+wdg_DACSetEdit.text);
        inc(k);
    end;


    ListData.Lines.Add( HexBytesToString(0, k, buf) );
    HandleStatus( GenericVendorWrite( diOnly, $3C, 0, $0023, k, @buf ) );
end;

procedure TMainForm.EditKeyPress(Sender: TObject; var Key: Char);
begin
    Key := UpCase(Key);
end;

end.
