unit eepromWrite;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin, ComCtrls;

type
  TUSB_EEPROM_Utility = class(TForm)
    Label1: TLabel;
    addrEdit: TEdit;
    Label2: TLabel;
    dataEdit: TEdit;
    readBtn: TButton;
    writeBtn: TButton;
    ListData: TMemo;
    ReadUSR: TButton;
    ReadDEF: TButton;
    ReadWDG: TButton;
    ReadMAP: TButton;
    ReadPNP: TButton;
    ListClear: TButton;
    GroupBox1: TGroupBox;
    RestoreTime: TTimer;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    WriteLenLabel: TLabel;
    ReqEdit: TEdit;
    ValueEdit: TEdit;
    IndexEdit: TEdit;
    WriteButton: TButton;
    ReadButton: TButton;
    ReadLenEdit: TEdit;
    WriteDataEdit: TEdit;
    ReadDataEdit: TEdit;
    SaveButton: TButton;
    AutosaveCheck: TCheckBox;
    SuccLabel: TLabel;
    SetDefaults: TButton;
    RestoreDefaults: TButton;
    WatchdogVR: TButton;
    WatchdogEEPROMVR: TButton;
    docMemo: TMemo;
    pnpTimer: TTimer;
    pnpMemo: TMemo;
    dioVR: TButton;
    dioConfigVR: TButton;
    StatusBar1: TStatusBar;
    ctrPanel: TGroupBox;
    StartOutputFrequency: TButton;
    ctrModeLost: TButton;
    ctrModeOnly: TButton;
    ctrBlockEdit: TEdit;
    ctrEdit: TEdit;
    ctrModeEdit: TEdit;
    ctrLoadEdit: TEdit;
    actualFreqEdit: TEdit;
    freqEdit: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    dioBox: TGroupBox;
    dioCB: TCheckBox;
    daqTimer: TTimer;
    dioLabel: TLabel;
    ctrBox: TGroupBox;
    ctrLabel: TLabel;
    ctrCB: TCheckBox;
    LATCHPanel: TGroupBox;
    latchEdit: TEdit;
    latchBtn: TButton;
    DEBPanel: TGroupBox;
    debTickEdit: TEdit;
    Button1: TButton;
    debTimeEdit: TEdit;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    GlobalTickPanel: TGroupBox;
    Label17: TLabel;
    globalTickEdit: TEdit;
    Button2: TButton;
    pwmPanel: TGroupBox;
    pwmBitEdit1: TEdit;
    pwmBitEdit2: TEdit;
    pwmBitEdit3: TEdit;
    pwmBitEdit4: TEdit;
    pwmBitEdit5: TEdit;
    pwmBitEdit6: TEdit;
    pwmBitEdit7: TEdit;
    pwmBitEdit0: TEdit;
    Label18: TLabel;
    Label19: TLabel;
    pwmTickEdit: TEdit;
    Label20: TLabel;
    pwmDutyEdit0: TEdit;
    pwmDutyEdit1: TEdit;
    pwmDutyEdit2: TEdit;
    pwmDutyEdit3: TEdit;
    pwmDutyEdit4: TEdit;
    pwmDutyEdit5: TEdit;
    pwmDutyEdit6: TEdit;
    pwmDutyEdit7: TEdit;
    Label21: TLabel;
    pwmCountEdit: TEdit;
    pwmConfigButton: TButton;
    pwmSetCountButton: TButton;
    pwmDebugMemo: TMemo;
    Label22: TLabel;
    pwmInvertCB0: TCheckBox;
    pwmInvertCB1: TCheckBox;
    pwmInvertCB2: TCheckBox;
    pwmInvertCB3: TCheckBox;
    pwmInvertCB4: TCheckBox;
    pwmInvertCB5: TCheckBox;
    pwmInvertCB6: TCheckBox;
    pwmInvertCB7: TCheckBox;
    ltchCB: TCheckBox;
    debCB: TCheckBox;
    mapPanel: TGroupBox;
    mapSB: TScrollBox;
    mapSrcEdit0: TEdit;
    mapInvCB0: TCheckBox;
    mapDstEdit0: TEdit;
    Label27: TLabel;
    Edit2: TEdit;
    Edit1: TEdit;
    Label26: TLabel;
    Label25: TLabel;
    Label24: TLabel;
    Label23: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure readBtnClick(Sender: TObject);
    procedure writeBtnClick(Sender: TObject);
    procedure addrEditKeyPress(Sender: TObject; var Key: Char);
    procedure ReadUSRClick(Sender: TObject);
    procedure ReadDEFClick(Sender: TObject);
    procedure ReadWDGClick(Sender: TObject);
    procedure ReadMAPClick(Sender: TObject);
    procedure ListClearClick(Sender: TObject);
    procedure WriteButtonClick(Sender: TObject);
    procedure WriteDataEditChange(Sender: TObject);
    procedure ReadButtonClick(Sender: TObject);
    procedure RestoreTimeTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure ListScrollEndClick(Sender: TObject);
    procedure SetDefaultsClick(Sender: TObject);
    procedure RestoreDefaultsClick(Sender: TObject);
    procedure WatchdogVRClick(Sender: TObject);
    procedure WatchdogEEPROMVRClick(Sender: TObject);
    procedure pnpTimerTimer(Sender: TObject);
    procedure dioVRClick(Sender: TObject);
    procedure dioConfigVRClick(Sender: TObject);
    procedure StartOutputFrequencyClick(Sender: TObject);
    procedure ctrModeLostClick(Sender: TObject);
    procedure ctrModeOnlyClick(Sender: TObject);
    procedure daqTimerTimer(Sender: TObject);
    procedure latchBtnClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure pwmSetCountButtonClick(Sender: TObject);
    procedure pwmConfigButtonClick(Sender: TObject);
    procedure dioCBClick(Sender: TObject);
  private
    { Private declarations }
    diocount:LongWord;
    ctrcount:LongWord;
  public
     function ReadEEPROM( addr:Word; var size:LongWord; data:Pointer ): LongWord;
     procedure DumpEEPROMData( a: LongWord; tablename:string; flagLengthed:boolean; s:Longword );
     procedure DisplayHint(Sender: TObject);
     function HandleStatus( Status: LongWord ): LongWord;
    { Public declarations }
  end;

var
  USB_EEPROM_Utility: TUSB_EEPROM_Utility;

implementation

uses
  Registry, AIOUSB;

{$R *.DFM}

const
  SetKey = 'Software\ACCES\USBFirmware2.0_ETest\1.0\';

procedure TUSB_EEPROM_Utility.DisplayHint( Sender: TObject );
begin
  StatusBar1.SimpleText := GetLongHint(Application.Hint);
end;

function TUSB_EEPROM_Utility.ReadEEPROM( addr:Word; var size:LongWord; data:Pointer ): LongWord;
begin
     Result := GenericVendorRead( diOnly, $A2, addr, addr, size, data );
end;

procedure TUSB_EEPROM_Utility.FormCreate(Sender: TObject);
var
  Reg: TRegistry;
  Buf: String;
begin
    ctrPanel.ParentFont := False;
    ctrPanel.Font.Color := $00888888;

    Application.OnHint := DisplayHint;
    docMemo.ScrollBars := ssVertical;

    if QueryDeviceInfo(diOnly, nil, nil, nil, nil, nil) <> ERROR_SUCCESS then
    begin
        MessageBox(0, 'This program requires exactly one ACCES USB device be attached to the computer',
                    'ERROR', MB_OK or MB_ICONEXCLAMATION);
    end;

    Reg := TRegistry.Create(KEY_QUERY_VALUE);
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    if Reg.OpenKey(SetKey, False) then begin
      if Reg.ValueExists('Request') then ReqEdit.Text := IntToHex(Reg.ReadInteger('Request'), 2);
      if Reg.ValueExists('Value') then ValueEdit.Text := IntToHex(Reg.ReadInteger('Value'), 4);
      if Reg.ValueExists('Index') then IndexEdit.Text := IntToHex(Reg.ReadInteger('Index'), 4);
      if Reg.ValueExists('WriteData') then begin
        WriteDataEdit.Text := Reg.ReadString('WriteData');
        WriteDataEditChange(WriteDataEdit);
      end;
      if Reg.ValueExists('ReadLen') then ReadLenEdit.Text := IntToHex(Reg.ReadInteger('ReadLen'), 1);
      Buf := Reg.ReadString('LastDir');
      if Buf = 'I' then
        ReadButton.Default := True
      else if Buf = 'O' then
        WriteButton.Default := True
      ;
      if Reg.ValueExists('Autosave') then AutosaveCheck.Checked := Reg.ReadInteger('Autosave') <> 0;
    end;
    Reg.Free;
end;

procedure TUSB_EEPROM_Utility.pnpTimerTimer(Sender: TObject);
var
    msg:string;
    Status:LongWord;
    m:LongWord;
    ID:Word;
    nSize:Longword;
    name:String;
    data : LongWord;
    size : LongWord;
    buf : array[0..3] of byte;

begin
    if pnpTimer.tag <> 0 then
    begin
        m := GetDevices;
        if m = 0 then pnpMemo.Clear;
        nSize := 255;
        SetString(Name, nil, 256);
        Status := QueryDeviceInfo( diOnly, @ID, @nSize, PChar(name), @diocount, @ctrcount );
        SetLength( name, nSize );
        if Status <> 0 then begin
            pnpMemo.Lines.Add('Error: ' + IntToStr(Status)+ ' on trying to use diOnly');
            pnpMemo.Lines.Add('GetDevices returned ' + IntToHex(m, 8));
            ClearDevices();
            pnpTimer.tag := 1;
            exit;
        end;

        size := 2;
        ReadEEPROM( 3, size, @data );
        msg := '['+IntToHex(ID, 4) + '] ' + name + ' [' + IntToHex(data, 4) + ']' + #13; // display the PID that's in the EEPROM
        size := 3;
        Status := GenericVendorRead( diOnly, $A3, $8000, $0001, size, @buf );
        pnpTimer.Tag := Status;
        if (buf[0] = 3) and (buf[2] = 3) then begin
            msg := msg + 'Firmware 2.0 detected' + #13;
            if ctrcount <> 0 then
            begin
                msg := msg + IntToHex(ctrcount, 2) + ' Counter Blocks';
                if diocount <> 0 then
                    msg := msg + ' and ';
                ctrPanel.ParentFont := True;
                ctrPanel.Enabled := True;
            end
                else begin ctrPanel.ParentFont := False; ctrPanel.Enabled := True; end;
            if diocount <> 0 then msg := msg + IntToHex(diocount,2) + ' DIO Bytes';
            pnpTimer.tag := 0;
        end else begin
            msg := msg + 'incompatible firmware detected /@8000 = ' + IntToHex(buf[0],2) + ' ' + IntToHex(buf[1],2) + ' ' + IntToHex(buf[2],2) + '/' + #13;
            msg := msg + 'do not use most of this program or you''ll experience lockups and other errors.';
            pnpTimer.tag := 1;
        end;

        pnpMemo.Lines.text := msg;
    end;
end;

procedure TUSB_EEPROM_Utility.writeBtnClick(Sender: TObject);
var
address : LongWord;
data : LongWord;
  Status: LongWord;

begin
    address := StrToIntDef('$' + addrEdit.Text, $200);

    data := StrToIntDef('$' + dataEdit.Text, $100);

    if data > $ff then exit;

    Status :=HandleStatus(  GenericVendorWrite( diOnly, $A2, address, address, 1, @data ) );
    pnpTimer.tag := Status;
    if Status = ERROR_SUCCESS then
        ListData.Lines.Add('0x' + IntToHex(address, 4) + ' < ' + IntToHex(data, 2));
end;

procedure TUSB_EEPROM_Utility.addrEditKeyPress(Sender: TObject; var Key: Char);
begin
    Key := UpCase(Key);
end;

procedure TUSB_EEPROM_Utility.readBtnClick(Sender: TObject);
var
    address : Word;
    data : LongWord;
    size : LongWord;
begin
    address := StrToIntDef('$' + addrEdit.Text, $1FFF);
    size := 1;
    HandleStatus( ReadEEPROM(address, size, @data) );
    ListData.Lines.Add('0x' +IntToHex(address,4) + ': ' + IntToHex(data, 2));
end;

procedure TUSB_EEPROM_Utility.ListClearClick(Sender: TObject);
begin
    ListData.Clear;
end;


function ErrorText(ErrorCode: LongWord): String;
var
  WindowsError: PChar;

begin
  FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER + FORMAT_MESSAGE_FROM_SYSTEM, nil, ErrorCode, 0, PChar(@WindowsError), 0, nil);
  Result := WindowsError;
  LocalFree(Cardinal(WindowsError));
end;

function NybbleToHex(N: Byte): Char;
begin
  N := N and $F;
  if N < 10 then
    Result := Char(Byte('0') + N)
  else
    Result := Char(Byte('A') - 10 + N)
  ;
end;

function StrToHex(Text: String): String;
var
  I: Integer;

begin
  SetString(Result, nil, Length(Text) * 2);
  for I := 1 to Length(Text) do begin
    Result[I * 2 - 1] := NybbleToHex(Byte(Text[I]) shr 4);
    Result[I * 2]     := NybbleToHex(Byte(Text[I])      );
  end;
end;

function StrToSpacedHex(Text: String): String;
var
  I: Integer;

begin
  SetString(Result, nil, Length(Text) * 3);
  for I := 1 to Length(Text) do begin
    Result[I * 3 - 2] := ' ';
    Result[I * 3 - 1] := NybbleToHex(Byte(Text[I]) shr 4);
    Result[I * 3]     := NybbleToHex(Byte(Text[I])      );
  end;
end;

function StringReplaceC(const S: String; const OldChar, NewChar: Char): String;
var
  I: Integer;

begin
  Result := S;
  for I := 1 to Length(Result) do
    if Result[I] = OldChar then
      Result[I] := NewChar
  ;
end;

function ValidateHexText(S: String): String;
var
  Content: TStringList;
  Buf: String;
  I, L: Integer;

begin
  S := StringReplaceC(S, ',', #13);
  S := StringReplaceC(S, ' ', #13);
  Content := TStringList.Create;
  try
    Content.Text := S;
    S := '';
    for I := Content.Count - 1 downto 0 do //Clear blank bytes and double delimiters
      if Length(Content[I]) = 0 then
        Content.Delete(I)
    ;
    L := Content.Count;
    SetString(Result, nil, L);
    for I := 0 to L - 1 do begin
      Buf := Content[I];
      Result[I + 1] := Char(StrToInt('$' + Buf));
    end;
  finally
    Content.Free;
  end;
end;

procedure TUSB_EEPROM_Utility.WriteDataEditChange(Sender: TObject);
begin
  try
    WriteLenLabel.Caption := IntToStr(Length(ValidateHexText(WriteDataEdit.Text)));
    WriteDataEdit.Color := clWindow;
    WriteDataEdit.Font.Color := clWindowText;
  except
    WriteLenLabel.Caption := '';
    WriteDataEdit.Color := $0000FF;
    WriteDataEdit.Font.Color := $FFFFFF;
  end;
end;

procedure TUSB_EEPROM_Utility.WriteButtonClick(Sender: TObject);
var
  I: LongWord;
  Buf: String;
  Status: LongWord;

begin
  I := diOnly;

  ReadButton.Default := False;
  WriteButton.Default := True;

  Buf := ValidateHexText(WriteDataEdit.Text);
  Status :=HandleStatus(  GenericVendorWrite(I, StrToInt('$' + ReqEdit.Text), StrToInt('$' + ValueEdit.Text), StrToInt('$' + IndexEdit.Text), Length(Buf), PChar(Buf)) );
  pnpTimer.tag := Status;
  if Status = ERROR_SUCCESS then begin
    SuccLabel.Caption := '';
    SuccLabel.Color := $00FF00;
  end
  else begin
    SuccLabel.Caption := IntToStr(Status) + ': ' + Trim(ErrorText(Status));
    SuccLabel.Color := $0000FF;
  end;
  RestoreTime.Enabled := True;
  Buf := '';
end;

procedure TUSB_EEPROM_Utility.ReadButtonClick(Sender: TObject);
var
  I: LongWord;
  Buf: String;
  L: LongWord;
  Status: LongWord;

begin
  I := diOnly;

  WriteButton.Default := False;
  ReadButton.Default := True;

  L := StrToInt(ReadLenEdit.Text);
  SetString(Buf, nil, L);
  Status := HandleStatus(  GenericVendorRead(I, StrToInt('$' + ReqEdit.Text), StrToInt('$' + ValueEdit.Text), StrToInt('$' + IndexEdit.Text), L, PChar(Buf)) );
  pnpTimer.tag := Status;  
  if Status = ERROR_SUCCESS then begin
    SetLength(Buf, L);
    ReadDataEdit.Text := Trim(StrToSpacedHex(Buf));
    ReadLenEdit.Text := IntToStr(L);
  end
  else begin
    SuccLabel.Caption := IntToStr(Status) + ': ' + Trim(ErrorText(Status));
    SuccLabel.Color := $0000FF;
  end;
  RestoreTime.Enabled := True;
  Buf := '';
end;

procedure TUSB_EEPROM_Utility.RestoreTimeTimer(Sender: TObject);
begin
  RestoreTime.Enabled := False;
  SuccLabel.ParentColor := True;
end;

procedure TUSB_EEPROM_Utility.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;


procedure TUSB_EEPROM_Utility.FormDestroy(Sender: TObject);
var
  Reg: TRegistry;

begin
  if AutosaveCheck.Checked then SaveButton.Click else begin
    Reg := TRegistry.Create(KEY_SET_VALUE);
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    if Reg.OpenKey(SetKey, True) then begin
      try Reg.WriteBool('Autosave', AutosaveCheck.Checked); except end;
    end;
    Reg.Free;
  end;
end;

procedure TUSB_EEPROM_Utility.SaveButtonClick(Sender: TObject);
var
  Reg: TRegistry;

begin
  Reg := TRegistry.Create(KEY_SET_VALUE);
  Reg.RootKey := HKEY_LOCAL_MACHINE;
  if Reg.OpenKey(SetKey, True) then begin
    try Reg.WriteInteger('Request', StrToInt('$' + ReqEdit.Text)); except end;
    try Reg.WriteInteger('Value', StrToInt('$' + ValueEdit.Text)); except end;
    try Reg.WriteInteger('Index', StrToInt('$' + IndexEdit.Text)); except end;
    try Reg.WriteString('WriteData', WriteDataEdit.Text); except end;
    try Reg.WriteInteger('ReadLen', StrToInt('$' + ReadLenEdit.Text)); except end;
    try
      if ReadButton.Default then
        Reg.WriteString('LastDir', 'I')
      else if WriteButton.Default then
        Reg.WriteString('LastDir', 'O')
      ;
    except
    end;
    try Reg.WriteBool('Autosave', AutosaveCheck.Checked); except end;
  end;
  Reg.Free;
end;


procedure TUSB_EEPROM_Utility.ListScrollEndClick(Sender: TObject);
begin
//    ListData.ItemIndex := ListData.Items.Count -1;
//    ListData.ItemIndex := -1;
end;

procedure TUSB_EEPROM_Utility.DumpEEPROMData( a: LongWord; tablename:string; flagLengthed:boolean; s:Longword );
var
    i, j, size:LongWord;
    data:array [0..255] of Byte;
    msg:string;
begin
    if ListData.Lines.Count > 0 then if (ListData.Lines.Strings[ListData.Lines.Count-1] <> '') then ListData.Lines.Add('');

    if (flagLengthed) then begin
        size := $1;
        if (HandleStatus(ReadEEPROM( a, size, @data )) <> ERROR_SUCCESS) then exit;
        if data[0] = $FF then data[0] := 0;
        size := data[0];
    end
    else
        size := s;

    if size > 0 then begin
        if (flagLengthed) then inc(size);
        if (HandleStatus(ReadEEPROM( a, size, @data )) <> ERROR_SUCCESS) then exit;
        i := 0;
        repeat
            msg := '0x' + IntToHex(a+i, 4) + ': ';
            for j := 0 to 15 do begin
                 if ((i+j) >= size) then
                     continue;
                 msg := msg + IntToHex(data[i+j], 2) + ' ';
            end; // j
            ListData.Lines.Add(msg);
            i := i + 16;
        until i >= size;
    end else begin
        ListData.Lines.Add('The '+tablename+' table is empty');
    end;

    if (ListData.Lines.Strings[ListData.Lines.Count-1] <> '') then ListData.Lines.Add('');

end;



function TUSB_EEPROM_Utility.HandleStatus( Status: LongWord ): LongWord;
begin
    pnpTimer.tag := Status;
    if Status = ERROR_SUCCESS then begin
        SuccLabel.Caption := '';
        SuccLabel.Color := $00FF00;
    end
    else begin
        SuccLabel.Caption := IntToStr(Status) + ': ' + Trim(ErrorText(Status));
        SuccLabel.Color := $0000FF;
    end;
    RestoreTime.Enabled := True;
    Result := Status;
end;

function byteArrayToBinary( bp:array of byte; c:integer):string;
var
  i:integer;
  b:byte;
begin
    for i := 1 to c do begin
        b := bp[i-1];
        result := IntToHex(b, 2) + ' ' + result;
    end;
end;


function CTR8254ArrayToBinary( wp:array of Word; c:integer):string;
var
  i:integer;
  w:Word;
begin
    result := '        ctr0 ctr1 ctr2' + #13;
    for i := 0 to c-1 do begin
        result := result + 'block '+IntToStr(i)+': ';
        w := wp[i*3];
        result := result + IntToHex(w, 4) + ' ';
        w := wp[i*3+1];
        result := result + IntToHex(w, 4) + ' ';
        w := wp[i*3+2];
        result := result + IntToHex(w, 4) + ' ';
        result := result + #13;
    end;

end;


procedure TUSB_EEPROM_Utility.daqTimerTimer(Sender: TObject);
var
    Buf:array[0..80] of Byte;
    Wuf:array[0..14] of Word;
    l:LongWord;
begin
    if (dioCB.checked) then begin
        DIO_ReadAll(diOnly, @Buf[0]);
        dioLabel.caption := byteArrayToBinary( Buf, 4 ) + ' Raw  ' ;

        if (ltchCB.checked) then begin
            l := dioCount *3;
            GenericVendorRead( diOnly, $14, $0000, $0000, l, @buf );
            dioLabel.caption := dioLabel.caption+#13+#10+
                                  byteArrayToBinary( Buf, dioCount )+' L Raw'+#13+#10+
                                  byteArrayToBinary( Buf[dioCount], dioCount )+' L Low'+#13+#10+
                                  byteArrayToBinary( Buf[dioCount*2], dioCount )+' L Hi ';
        end;
        if (debCB.checked) then begin
            l := dioCount;
            GenericVendorRead( diOnly, $15, $0000, $0000, l, @buf );
            dioLabel.caption := dioLabel.caption+#13+#10+byteArrayToBinary( Buf, dioCount )+' DEB  ';
        end;
    end;

    if (ctrCB.checked) then begin
        Fillchar(Wuf[0], 15*2, 0);
        HandleStatus(CTR_8254ReadAll(diOnly, @Wuf[0]));
        ctrLabel.caption := CTR8254ArrayToBinary( Wuf, ctrCount );
    end;
end;

procedure TUSB_EEPROM_Utility.ReadUSRClick(Sender: TObject);
begin
    DumpEEPROMData( $1E00, 'USER', FALSE, $100 );
end;

procedure TUSB_EEPROM_Utility.ReadDEFClick(Sender: TObject);
begin
    DumpEEPROMData($1F00, 'DEF', TRUE, 0 );
end;

procedure TUSB_EEPROM_Utility.ReadWDGClick(Sender: TObject);
begin
    DumpEEPROMData($1D80, 'WDG', TRUE, 0 );
end;

procedure TUSB_EEPROM_Utility.ReadMAPClick(Sender: TObject);
var
    address, i, size:LongWord;
    data:array [0..255] of Byte;
    msg:string;
begin
    if ListData.Lines.Count > 0 then if (ListData.Lines.Strings[ListData.Lines.Count-1] <> '') then ListData.Lines.Add('');
    size := $1;
    if (HandleStatus(ReadEEPROM( $1FFF, size, @data )) = ERROR_SUCCESS) then begin
        if data[0] = $FF then data[0] := 0;
        size := data[0] * 2;
        if size > 0 then begin
            ListData.Lines.Add('The MAP has ' + IntToStr(data[0]) + ' entries');
            address := $1FFF - size;

            ReadEEPROM( address, size, @data );
            i := 0;
            repeat
                msg := 'MAP[' + inttostr(i) + '] = ';
                msg := msg + 'bit ' + IntToHex( data[i], 2 ) + ' => bit ' + IntToHex( data[i+1] AND $7F, 2 );
                if  ((data[i+1] AND $80) = $80) then msg := msg + ' inverted';
                ListData.Lines.Add(msg);
                i := i + 2;
            until i >= size;
        end else begin
            ListData.Lines.Add('The MAP table is empty');
        end;

        if (ListData.Lines.Strings[ListData.Lines.Count-1] <> '') then ListData.Lines.Add('');
    end;
end;



procedure TUSB_EEPROM_Utility.SetDefaultsClick(Sender: TObject);
begin
    HandleStatus( GenericVendorWrite(diOnly, $3C, $ACCE, $0010, 0, nil) );
end;

procedure TUSB_EEPROM_Utility.RestoreDefaultsClick(Sender: TObject);
begin
    HandleStatus( GenericVendorWrite(diOnly, $3C, $ACCE, $0011, 0, nil) );
end;

procedure TUSB_EEPROM_Utility.WatchdogVRClick(Sender: TObject);
var
    msg:string;
    i:integer;
    s:LongWord;
    buf:byte;
begin
    s := 1;
    ReadEEPROM( $1D80, s, @buf );
    s := buf;

    ReqEdit.Text := '2E';
    ValueEdit.Text := '0000';
    IndexEdit.Text := '0000';
    msg := '';
    for i := 1 to s do begin
        msg := msg + '00 ';
    end;

    WriteDataEdit.Text := msg;

    ReadLenEdit.Text := IntToStr( s+3 );

    WriteButton.SetFocus;
end;

procedure TUSB_EEPROM_Utility.WatchdogEEPROMVRClick(Sender: TObject);
var
    msg:string;
    i:integer;
    s:LongWord;
    buf:byte;
begin
    s := 1;
    ReadEEPROM( $1D80, s, @buf );
    s := buf;

    ReqEdit.Text := '2E';
    ValueEdit.Text := '0001';
    IndexEdit.Text := '0001';
    msg := '';
    for i := 1 to s do begin
        msg := msg + '00 ';
    end;

    WriteDataEdit.Text := msg;

    ReadLenEdit.Text := IntToStr( s+3 );

    WriteButton.SetFocus;
end;

procedure TUSB_EEPROM_Utility.dioVRClick(Sender: TObject);
var
    msg:string;
    i:integer;
    s:LongWord;
begin
    s := diocount;
    ReqEdit.Text := '10';
    ValueEdit.Text := '0000';
    IndexEdit.Text := '0000';
    msg := '';
    for i := 1 to s do begin
        msg := msg + '00 ';
    end;

    WriteDataEdit.Text := msg;
    ReadLenEdit.Text := IntToStr( s );
    ReadButton.SetFocus;
end;

procedure TUSB_EEPROM_Utility.dioConfigVRClick(Sender: TObject);
var
    msg:string;
    i:integer;
    s:LongWord;
begin
    s := diocount+1;
    ReqEdit.Text := '12';
    ValueEdit.Text := '0000';
    IndexEdit.Text := '0000';
    msg := '';
    for i := 1 to s do begin
        msg := msg + '00 ';
    end;

    WriteDataEdit.Text := msg;
    ReadLenEdit.Text := IntToStr( s );
    WriteButton.SetFocus;
end;


procedure TUSB_EEPROM_Utility.StartOutputFrequencyClick(Sender: TObject);
var
    f:double;
    Status:LongWord;
begin
    f := StrToFloat( FreqEdit.text );
    Status := HandleStatus( CTR_StartOutputFreq( diOnly, StrToInt(ctrBlockEdit.Text), @f) );
    if Status = ERROR_SUCCESS then begin
        actualFreqEdit.Text := FloatToStr(f);
    end
    else begin
        actualFreqEdit.Text := '';
    end;
end;

procedure TUSB_EEPROM_Utility.ctrModeLostClick(Sender: TObject);
var
    m : byte;

begin
    m := (StrToInt(ctrEdit.Text) shl 6) OR $30 OR (StrToInt(ctrModeEdit.text) shl 1);
    HandleStatus( CTR_8254ModeLoad( diOnly, StrToInt(ctrBlockEdit.Text), StrToInt(ctrEdit.Text), m, StrToInt('$'+ctrLoadEdit.Text) ) );

end;

procedure TUSB_EEPROM_Utility.ctrModeOnlyClick(Sender: TObject);
var
    m : byte;
begin
    m := (StrToInt(ctrEdit.Text) shl 6) OR $30 OR (StrToInt(ctrModeEdit.text) shl 1);
    HandleStatus( CTR_8254Mode( diOnly, StrToInt(ctrBlockEdit.Text), StrToInt(ctrEdit.Text), m )) ;
end;


procedure TUSB_EEPROM_Utility.latchBtnClick(Sender: TObject);
var tdiv:byte;
begin
    tdiv :=  StrToInt('$'+latchEdit.Text);
    HandleStatus( GenericVendorWrite( diOnly, $3C, $0000, $0061, 1, @tdiv )) ;
end;

procedure TUSB_EEPROM_Utility.Button1Click(Sender: TObject);
var
    b:array[0..1] of byte;
begin
    b[0] :=  StrToInt('$'+debTickEdit.Text);
    b[1] :=  StrToInt('$'+debTimeEdit.Text);
    HandleStatus( GenericVendorWrite( diOnly, $3C, $0000, $0051, 2, @b )) ;
end;

procedure TUSB_EEPROM_Utility.Button2Click(Sender: TObject);
var gdiv:word;
begin
    gdiv :=  StrToInt('$'+globalTickEdit.Text);
    HandleStatus( GenericVendorWrite( diOnly, $3C, gdiv, $8001, 0, nil )) ;

end;

procedure TUSB_EEPROM_Utility.pwmSetCountButtonClick(Sender: TObject);
var count:byte;
begin
    HandleStatus( GenericVendorWrite( diOnly, $3C, $0000, $0073, 1, @count )) ;
end;

procedure TUSB_EEPROM_Utility.pwmConfigButtonClick(Sender: TObject);
TYPE
   pwm_struct_type = packed record
      TickDivisor:byte;
      PWM: array[0..7] of packed record
             BitIndex:byte;
             DutyCycleReload:byte;
      end;
      Count:byte;
   end;
VAR
   pwm:pwm_struct_type;
   i:byte;
begin
    pwmDebugMemo.Clear;

    pwm.TickDivisor := StrToInt(pwmTickEdit.Text);
    pwm.pwm[0].BitIndex := StrToInt(pwmBitEdit0.text) OR (ord(pwmInvertCB0.checked)*$80);
    pwm.pwm[0].DutyCycleReload := StrToInt(pwmDutyEdit0.Text);
    pwm.pwm[1].BitIndex := StrToInt(pwmBitEdit1.text) OR (ord(pwmInvertCB1.checked)*$80);
    pwm.pwm[1].DutyCycleReload := StrToInt(pwmDutyEdit1.Text);
    pwm.pwm[2].BitIndex := StrToInt(pwmBitEdit2.text) OR (ord(pwmInvertCB2.checked)*$80);
    pwm.pwm[2].DutyCycleReload := StrToInt(pwmDutyEdit2.Text);
    pwm.pwm[3].BitIndex := StrToInt(pwmBitEdit3.text) OR (ord(pwmInvertCB3.checked)*$80);
    pwm.pwm[3].DutyCycleReload := StrToInt(pwmDutyEdit3.Text);
    pwm.pwm[4].BitIndex := StrToInt(pwmBitEdit4.text) OR (ord(pwmInvertCB4.checked)*$80);
    pwm.pwm[4].DutyCycleReload := StrToInt(pwmDutyEdit4.Text);
    pwm.pwm[5].BitIndex := StrToInt(pwmBitEdit5.text) OR (ord(pwmInvertCB5.checked)*$80);
    pwm.pwm[5].DutyCycleReload := StrToInt(pwmDutyEdit5.Text);
    pwm.pwm[6].BitIndex := StrToInt(pwmBitEdit6.text) OR (ord(pwmInvertCB6.checked)*$80);
    pwm.pwm[6].DutyCycleReload := StrToInt(pwmDutyEdit6.Text);
    pwm.pwm[7].BitIndex := StrToInt(pwmBitEdit7.text) OR (ord(pwmInvertCB7.checked)*$80);
    pwm.pwm[7].DutyCycleReload := StrToInt(pwmDutyEdit7.Text);
    pwm.Count := StrToInt(pwmCountEdit.Text);

    pwmDebugMemo.Lines.Add(IntToStr(pwm.TickDivisor));
    for i := 0 to 7 do  begin
        pwmDebugMemo.Lines.Add(IntToHex(pwm.pwm[i].BitIndex, 2) + ' @ ' + IntToStr(pwm.pwm[i].DutyCycleReload));
    end;//i
    pwmDebugMemo.Lines.Add(IntToStr(pwm.Count));

    HandleStatus( GenericVendorWrite( diOnly, $3C, $0000, $0071, sizeof(pwm), @pwm )) ;

end;

procedure TUSB_EEPROM_Utility.dioCBClick(Sender: TObject);
begin
    ltchCB.enabled := dioCB.checked;
    debCB.enabled := dioCB.checked;
end;

end.
